/* Test structure passing by value.  */
/* { dg-do run } */
/* { dg-options "-O2" } */

#define T(N)					\
struct S##N { unsigned char i[N]; };		\
struct S##N g1s##N, g2s##N, g3s##N;		\
						\
void						\
init##N (struct S##N *p, int i)			\
{						\
  int j;					\
  for (j = 0; j < N; j++)			\
    p->i[j] = i + j;				\
}						\
						\
void						\
check##N (struct S##N *p, int i)		\
{						\
  int j;					\
  for (j = 0; j < N; j++)			\
    if (p->i[j] != i + j) abort ();		\
}						\
						\
void						\
test##N (struct S##N s1, struct S##N s2,	\
	 struct S##N s3)			\
{						\
  check##N (&s1, 64);				\
  check##N (&s2, 128);				\
  check##N (&s3, 192);				\
}						\
						\
void						\
test2_##N (struct S##N s1, struct S##N s2)	\
{						\
  test##N (s1, g2s##N, s2);			\
}						\
						\
void						\
testit##N (void)				\
{						\
  init##N (&g1s##N, 64);			\
  check##N (&g1s##N, 64);			\
  init##N (&g2s##N, 128);			\
  check##N (&g2s##N, 128);			\
  init##N (&g3s##N, 192);			\
  check##N (&g3s##N, 192);			\
  test##N (g1s##N, g2s##N, g3s##N);		\
  test2_##N (g1s##N, g3s##N);			\
}

extern void abort (void);
extern void exit (int);

T(32)

#undef T

int
main ()
{
#define T(N) testit##N ();

T(32)

#undef T
  exit (0);
}
